#  Trifid STool by ANCHISES
# 15 Dec 2007


transfer=['A']*112

#.....paste here Relationship Table from RTool ....
# NOTE:  after pasting the Relationship Table
#        add a backwards slash at the end of the 1st, 2nd and 3rd lines
#        as shown below, to join them all together in a single string.

transfer="A F I N P S T U [\
a d a a a c b b b\
b e a d a a a a c\
a e b a a e d b c"


# ...Declarations......
perm=[0]*20
alpha=['A'] * 27
sym=[0]*3
for row in range(3):
    sym[row]=[-1]*27    

trifid_grid=[None]*4
for row in range(4):
    trifid_grid[row]=[None]*27    

trifid_grid[1]= "111111111222222222333333333"
trifid_grid[2]= "111222333111222333111222333"
trifid_grid[3]= "123123123123123123123123123"

alphabet="ABCDEFGHIJKLMNOPQRSTUVWXYZ["

index=[0]*27
len_index=0
len_transfer=len(transfer)
beta=['A']*27
alpha_skim=['A']*1000
for row in range (1000):
    alpha_skim[row]=['A']*27
score_skim=[0]*1000    
nr_skim=len_beta=0
rib=['A']*100
site=[0]*27

#...........START.....................................
#... Put transfer into rib[], omitting spaces....
t=-1
for m in range(len_transfer):
    if(transfer[m]!=' '):
        t=t+1; rib[t]=transfer[m]
len_transfer=t+1        

# ....make index[] from rib[], as order nrs......    
len_index=0    
for m in range (len_transfer/4):
    if rib[m]=='#':
        index[len_index]=26
    else:
        index[len_index]=ord(rib[m])-65
    len_index=len_index+1
    
#..get symbols from transfer[], convert to integers & put into sym[][]
row=0; col=-1; maxi=-1
for m in range (len_transfer/4,len_transfer):
    if rib[m]> 96:
        col=col+1
        if(col==len_index):
            col=0;row=row+1
        sym[row][col]=ord(rib[m])-97
        if(sym[row][col]>maxi):
            maxi=sym[row][col]      
#....prune transfer if more than 14 symbols.......
x=-1;            
for col in range(len_index):
    if sym[0][col]<14 and sym[1][col]<14 and sym[2][col]<12:
        x=x+1
        index[x]=index[col]
        sym[0][x]=sym[0][col]; sym[1][x]=sym[1][col]; sym[2][x]=sym[2][col]
len_index=x+1
maxi=0
for row in range(3):
    for col in range(len_index):
        if(sym[row][col]>maxi):
            maxi=sym[row][col]   
            
print "There are a total of ",maxi+1," symbols"
print "Here is Relationship Table:"
for col in range (len_index):
    if(index[col]==26): print "#",
    else: print alphabet[index[col]],
print    
for row in range (3):
    for col in range(len_index):
        print chr(sym[row][col]+97),
    print
print
print "Now solving ....please wait...."
#...begin assessment routine...
all_done=0; nr_skim=0;
fi=se=th=v1=v2=v3=pos=0
x=y=z=0
score=bestscore=0


for m in range(maxi+1): # maxi is highest symbol, lowest is 0
    perm[m]=0
  
while all_done<1: 
    n=maxi
    perm[n]=perm[n]+1  # get next perm
    
    while perm[n]==3:  # if next perm[n] is 3, correct
        perm[n]=0
        n=n-1
        if n<0:
            all_done=1
            print "ALL  DONE ... here are results"
        else:
            perm[n]=perm[n]+1

    for m in range (27):  # clear alpha[] for next perm
         alpha[m]='.'
    bad=0
    
    for p in range(len_index):
        fi=sym[0][p]; se=sym[1][p]; th=sym[2][p]   # symbols
        v1=perm[fi]; v2=perm[se]; v3=perm[th]      # coordinates
        pos=v1*9 + v2*3 + v3                  #position in mixed alphabet
        if alpha[pos]>='A':                # letter already present
            bad=1                                   # conflict
            break
        else:
            alpha[pos]=alphabet[index[p]]           # OK, insert letter
   #....scoring routine.....       
    if bad == 0:
        #..Put letters from alpha[] into beta[], omitting spaces..
        #..Put position of letters in alpha[] into site[]...
        t=-1
        for m in range(26,-1,-1):
            if(alpha[m]>='A' and alpha[m]<='['):
                t=t+1; beta[t]=alpha[m]
                site[t]=m
        len_beta=t+1
        score=0
        for m in range(len_beta-1):
            if(ord(beta[m+1])>ord(beta[m])): break   # out of a-order
            else:
                diff1=ord(beta[m])-ord(beta[m+1])
                diff2=site[m]-site[m+1]
                if(diff1<diff2): break              # discontinuity
        score=m+1            
        if score >= bestscore:
            bestscore=score
        if score >= bestscore-1:         # remember for later
            score_skim[nr_skim]=score;
            for m in range(27):
                alpha_skim[nr_skim][m]=alpha[m]
            nr_skim=nr_skim+1
            
#...report results......
       
print "bestscore=",bestscore
for x in range(nr_skim+1):
    if score_skim[x]>bestscore-2:
        print score_skim[x],"   ",
        for m in range (27):
            if(alpha_skim[x][m]=='['):print"#",
            else: print alpha_skim[x][m],
        print
print
print "END"
        
       
    
    
          



   




   
